#include-once

#include <GDIPlus.au3>
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include <array.au3>

;#include ".\AutoIt\Smooth.au3"
Global $aDll[10][3] = [[5]]
$aDll[1][0] = DllOpen(@ScriptDir & "\FreeBasic\Smooth.dll")
$aDll[1][1] = "FreeBasic"
$aDll[1][2] = "Smooth"
$aDll[2][0] = DllOpen(@ScriptDir & "\Lazarus\Smooth.dll")
$aDll[2][1] = "Lazarus"
$aDll[2][2] = "Smooth"
$aDll[3][0] = DllOpen(@ScriptDir & "\FreePascal\Smooth.dll")
$aDll[3][1] = "FreePascal"
$aDll[3][2] = "Smooth"
$aDll[4][0] = DllOpen(@ScriptDir & "\DevC\Smooth.dll")
$aDll[4][1] = "DevC"
$aDll[4][2] = "Smooth"
$aDll[5][0] = DllOpen(@ScriptDir & "\MinGW\Smooth.dll")
$aDll[5][1] = "MinGW"
$aDll[5][2] = "Smooth@12"

Global $asmdll = DllOpen(@ScriptDir & "\Smooth.dll")
ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $asmdll = ' & $asmdll & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console

Global $iSteps = 10
Global $iPoints = 20000

;Opt("MustDeclareVars", 1)
Opt("GUIOnEventMode", 1)

Global $iWidth = @DesktopWidth * 0.8
Global $iHeight = @DesktopHeight * 0.8


_GDIPlus_Startup()
Global $hGui = GUICreate("Test", $iWidth, $iHeight)
GUISetOnEvent($GUI_EVENT_CLOSE, "_Exit")
Global $hGraphics = _GDIPlus_GraphicsCreateFromHWND($hGui)
Global $hBmpBuffer = _GDIPlus_BitmapCreateFromGraphics($iWidth, $iHeight, $hGraphics)
Global $hGfxBuffer = _GDIPlus_ImageGetGraphicsContext($hBmpBuffer)
_GDIPlus_GraphicsSetSmoothingMode($hGfxBuffer, 2)
_GDIPlus_GraphicsClear($hGfxBuffer, 0xFF000000)

Global $hPen = _GDIPlus_PenCreate(0xFF00FF00, 1)

GUIRegisterMsg($WM_PAINT, "WM_PAINT")
GUISetState()

Global $aPoints = _CreateRandomPoints($iWidth, $iHeight, $iPoints)
Global $tPoints = _CreatePointsStruct($aPoints)
ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $tPoints = ' & DllStructGetPtr($tPoints) & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console




_GDIPlus_GraphicsClear($hGfxBuffer, 0xFF000000)
DllCall($ghGDIPDll, "uint", "GdipDrawClosedCurve2", "hwnd", $hGfxBuffer, "hwnd", $hPen, "ptr", DllStructGetPtr($tPoints), "int", $iPoints, "float", 0)
_GDIPlus_GraphicsDrawImage($hGraphics, $hBmpBuffer, 0, 0)
MsgBox(0, "original curve", "click ok to start...")

ConsoleWrite("!==============================================" & @CRLF)

_Smooth_Asmdll($tPoints, $iPoints, $iSteps)

For $i = 1 To $aDll[0][0]
    _Smooth_Dll($aDll[$i][0], $aDll[$i][1], $aDll[$i][2], $tPoints)
Next
ConsoleWrite("!==============================================" & @CRLF)

While 1
    Sleep(10)
WEnd


Func _Smooth_Dll($hDll, $sText, $sFunc, $tSrcPnts)
    Local $tBytes = DllStructCreate("byte[" & DllStructGetSize($tSrcPnts) & "];", DllStructGetPtr($tSrcPnts))
    Local $bBytes = DllStructGetData($tBytes, 1)
    Local $tPoints = DllStructCreate("float[" & $iPoints * 2 & "];")
    $tBytes = DllStructCreate("byte[" & DllStructGetSize($tPoints) & "];", DllStructGetPtr($tPoints))
    DllStructSetData($tBytes, 1, $bBytes)
    Local $pPoints = DllStructGetPtr($tPoints)
    Local $fTime
    Local $iTimer = TimerInit()
    DllCall($hDll, "dword", $sFunc, "ptr", $pPoints, "dword", $iPoints, "dword", $iSteps)
    If @error Then
        ConsoleWrite("! Error calling " & $sText & " dll" & @CRLF)
        Return
    EndIf
    $fTime = TimerDiff($iTimer)
    ConsoleWrite("> " & $sText & ": " & $fTime & @CRLF)
    _GDIPlus_GraphicsClear($hGfxBuffer, 0xFF000000)
    DllCall($ghGDIPDll, "uint", "GdipDrawClosedCurve2", "hwnd", $hGfxBuffer, "hwnd", $hPen, "ptr", DllStructGetPtr($tPoints), "int", $iPoints, "float", 0.5)
    _GDIPlus_GraphicsDrawImage($hGraphics, $hBmpBuffer, 0, 0)
    MsgBox(0, $sText, $fTime)
EndFunc                                ;==>_Smooth_Dll



Func _Smooth_Autoit($aPoints)
    Local $fTime
    Local $iTimer = TimerInit()
    _Smooth($aPoints, $iSteps)
    $fTime = TimerDiff($iTimer)
    ConsoleWrite("> AutoIt: " & $fTime & @CRLF)
    Local $tPoints = _CreatePointsStruct($aPoints)
    _GDIPlus_GraphicsClear($hGfxBuffer, 0xFF000000)
    DllCall($ghGDIPDll, "uint", "GdipDrawClosedCurve2", "hwnd", $hGfxBuffer, "hwnd", $hPen, "ptr", DllStructGetPtr($tPoints), "int", $iPoints, "float", 0.5)
    _GDIPlus_GraphicsDrawImage($hGraphics, $hBmpBuffer, 0, 0)
    MsgBox(0, "AutoIt", $fTime)
EndFunc                                ;==>_Smooth_Autoit



Func _CreateRandomPoints($iW, $iH, $iC, $iType = 2)
    Local $aPoints[$iC + 1][2] = [[$iC]]
    Switch $iType
        Case 1
            For $i = 1 To $iC
                $aPoints[$i][0] = Random(0, $iW)
                $aPoints[$i][1] = Random(0, $iH)
            Next
        Case Else
            Local $iR = 10
            Local $iX, $iY, $iTX, $iTY, $iStep = 0
            $iX = Random(0, $iW)
            $iY = Random(0, $iH)
            While 1
                $iTX = Random(0, $iW, 1)
                $iTY = Random(0, $iH, 1)
                For $i = 1 To $iR
                    $iStep += 1
                    If $iStep > $iC Then Return $aPoints
                    $aPoints[$iStep][0] = $iX + ($i * ($iTX - $iX) / $iR) + Random(-20, 20)
                    $aPoints[$iStep][1] = $iY + ($i * ($iTY - $iY) / $iR) + Random(-20, 20)
                Next
                $iX = $iTX
                $iY = $iTY
            WEnd
    EndSwitch
    Return $aPoints
EndFunc                                ;==>_CreateRandomPoints

Func _CreatePointsStruct($aPoints)
    Local $tPoints = DllStructCreate("float[" & $aPoints[0][0] * 2 + 8 & "];")
    For $i = 1 To $aPoints[0][0]
        DllStructSetData($tPoints, 1, $aPoints[$i][0], ($i - 1) * 2 + 1)
        DllStructSetData($tPoints, 1, $aPoints[$i][1], ($i - 1) * 2 + 2)
    Next
    Return $tPoints
EndFunc                                ;==>_CreatePointsStruct

Func WM_PAINT($hWnd, $uMsgm, $wParam, $lParam)
    _GDIPlus_GraphicsDrawImage($hGraphics, $hBmpBuffer, 0, 0)
    Return $GUI_RUNDEFMSG
EndFunc                                ;==>WM_PAINT

Func _Exit()
    For $i = 1 To $aDll[0][0]
        DllClose($aDll[$i][0])
    Next
    _GDIPlus_PenDispose($hPen)
    _GDIPlus_GraphicsDispose($hGfxBuffer)
    _GDIPlus_BitmapDispose($hBmpBuffer)
    _GDIPlus_GraphicsDispose($hGraphics)
    _GDIPlus_Shutdown()
    Exit
EndFunc                                ;==>_Exit


Func _Smooth(ByRef $aP, $iS = 1)
    Local $iI = $aP[0][0]
    For $s = 1 To $iS
        $aP[1][0] = _B($aP[$iI][0], $aP[1][0], $aP[2][0], $aP[3][0])
        $aP[1][1] = _B($aP[$iI][1], $aP[1][1], $aP[2][1], $aP[3][1])
        For $i = 2 To $iI - 2
            $aP[$i][0] = _B($aP[$i - 1][0], $aP[$i][0], $aP[$i + 1][0], $aP[$i + 2][0])
            $aP[$i][1] = _B($aP[$i - 1][1], $aP[$i][1], $aP[$i + 1][1], $aP[$i + 2][1])
        Next
        $aP[$iI - 1][0] = _B($aP[$iI - 2][0], $aP[$iI - 1][0], $aP[$iI][0], $aP[1][0])
        $aP[$iI - 1][1] = _B($aP[$iI - 2][1], $aP[$iI - 1][1], $aP[$iI][1], $aP[1][1])
        $aP[$iI][0] = _B($aP[$iI - 1][0], $aP[$iI][0], $aP[1][0], $aP[2][0])
        $aP[$iI][1] = _B($aP[$iI - 1][1], $aP[$iI][1], $aP[1][1], $aP[2][1])
    Next
EndFunc                                ;==>_Smooth

Func _B($1, $2, $3, $4, $t = 0.5)
    Local $V1, $V2, $V3, $V4
    $V1 = (-$1 + 3 * $2 - 3 * $3 + $4) / 6.0
    $V2 = (3 * $1 - 6 * $2 + 3 * $3) / 6.0
    $V3 = (-3 * $1 + 3 * $3) / 6.0
    $V4 = ($1 + 4 * $2 + $3) / 6.0
    Return ($V3 + $t * ($V2 + $t * $V1)) * $t + $V4
EndFunc                                ;==>_B


Func _smooth_asmdll($tSrcPnts, $iPoints, $iSteps)

    Local $tBytes = DllStructCreate("byte[" & DllStructGetSize($tSrcPnts) & "];", DllStructGetPtr($tSrcPnts))
    Local $bBytes = DllStructGetData($tBytes, 1);inhalt orginal struct
    Local $tPoints = DllStructCreate("float[" & ($iPoints + 2) * 2 & "];");neue struct
    $tBytes = DllStructCreate("byte[" & DllStructGetSize($tPoints) & "];", DllStructGetPtr($tPoints));inhalt neue
    DllStructSetData($tBytes, 1, $bBytes)
    Local $pPoints = DllStructGetPtr($tPoints);pointer neue
    $iTimer = TimerInit()
    ; $a=_assembleit("int", "_asm", "ptr", $ppoints,"int",$ipoints,"int",$isteps)
    $ret = DllCall($asmdll, "int", "Smooth", "ptr", $pPoints, "int", $iPoints, "int", $iSteps)
    $fTime = TimerDiff($iTimer)
    _GDIPlus_GraphicsClear($hGfxBuffer, 0xFF000000)

    DllCall($ghGDIPDll, "uint", "GdipDrawClosedCurve2", "hwnd", $hGfxBuffer, "hwnd", $hPen, "ptr", DllStructGetPtr($tPoints), "int", $iPoints, "float", 0.5)
    _GDIPlus_GraphicsDrawImage($hGraphics, $hBmpBuffer, 0, 0)
    MsgBox(0, "asmcode", $fTime)
    $tBytes = 0
EndFunc                                ;==>_smooth_asmdll


;~ Func _asm()
;~     _("use32")
;~     _("org " & FasmGetBasePtr($Fasm))

;~     _("mov eax,[esp+4]")               ;pointer struct $pPoints
;~     _("mov ebx,[esp+8]")               ;anzahl punkte   $iPoints
;~     _("mov ecx,[esp+12]")              ;steps    $iSteps
;~     _("mov edx,ebx")                   ;anzahl punkte   $iPoints
;~     _("sub edx,1")
;~     _("add ebx,4")                     ;hinten in der struct 4 punkte
;~     _("shl ebx,3")                     ;es werden immer 4 koordinaten = 16 Byte gleichzeitig berechnet
;~     _("sub ebx,48")
;~     _("add ebx,eax")                   ;endadresse

;~     ;register belegen
;~     _("movups xmm5,dqword[_mem5]")     ;3
;~     _("movups xmm6,dqword[_mem6]")     ;-1
;~     _("movups xmm7,xmm5")              ;3
;~     _("addps xmm7,xmm7")               ;6
;~     _("rcpps xmm7,xmm7")               ;1/6

;~     _("align 16")
;~     _("_steploop:")                    ;x1,y1,x2,y2
;~     _("movups xmm1,[eax+edx*8]")
;~     _("movups xmm2,[eax]")
;~     _("movlhps xmm1,xmm2")
;~     _("movups xmm3,[eax+8]")
;~     _("movups xmm4,[eax+16]")
;~     _("call _b")                       ;_b()
;~     ;es werden 4 koordinatenpunkte gleichzeitig berechnet!
;~     ;x0,y0,x1,x2
;~     _("movups dqword[eax],xmm0")       ;x0,y0,x1,y1 in struct schreiben
;~     _("movups dqword[eax+edx*8+8],xmm0");x0,y0,x1,y1 struct hinten auffllen

;~     _("align 16")
;~     _("_iloop:")                       ; For $i = 2 To $iI - 2
;~     _("add eax,16")                    ;2 punkte weiter
;~     _("movups xmm1,[eax-8]")
;~     _("movups xmm2,[eax]")
;~     _("movups xmm3,[eax+8]")
;~     _("movups xmm4,[eax+16]")
;~     _("call _b")                       ;_b()
;~     _("movups dqword[eax],xmm0")       ;neue x0,y0,x1,y1 in struct schreiben
;~     _("cmp eax,ebx")                   ;wenn ende erreicht, dann raus
;~     _("jl _iloop")                     ;
;~     _("je _gerade")                    ;wenn adresse endpunkt getroffen
;~     ;adresse hinter endpunkt getroffen
;~     _("sub ecx,1")                     ;steps erreicht?
;~     _("jz _ende")                      ;ja, dann ende
;~     _("mov eax,[esp+4]")               ;adresse auf anfang struct
;~     _("movups xmm0,dqword[eax+edx*8+8]");x0,y0,x1,y1 von struct hinten holen
;~     _("movups dqword[eax],xmm0")       ;x0,y0,x1,y1 vorne einsetzen
;~     _("sub eax,8")                     ;adresse anpassen auf 2. punkt
;~     _("jmp _iloop")                    ;und struct am 2. punkt beginnen
;~     _("_gerade:")
;~     _("mov eax,[esp+4]")               ;adresse auf anfang struct
;~     _("sub ecx,1")                     ;steps erreicht?
;~     _("jnz _steploop")                 ;und struct von vorne beginnen
;~     _("_ende:")
;~     _("mov eax,[esp+4]")               ;
;~     _("ret")                           ;programmende

;~     _("align 16")
;~     _("_b:")
;~     _("")                              ;v1
;~     _("movaps xmm0,xmm2")
;~     _("mulps xmm0,xmm5")
;~     ;    _("prefetchw [_mem1]")
;~     _("movaps dqword[_mem1],xmm0")
;~     _("movaps xmm0,xmm3")
;~     _("mulps xmm0,xmm5")
;~     _("movaps dqword[_mem2],xmm0")
;~     _("movaps xmm0,xmm1")

;~     _("mulps xmm0,xmm6")
;~     _("addps xmm0,dqword[_mem1]")
;~     _("subps xmm0,dqword[_mem2]")
;~     _("addps xmm0,xmm4")
;~     _("mulps xmm0,xmm7")
;~     _("movaps xmm4,xmm0")              ;xmm4=v1
;~     _("")                              ;v2
;~     _("movaps xmm0,xmm1")
;~     _("mulps xmm0,xmm5")
;~     _("subps xmm0,dqword[_mem1]")
;~     _("subps xmm0,dqword[_mem1]")
;~     _("addps xmm0,dqword[_mem2]")
;~     _("mulps xmm0,xmm7")
;~     _("movaps dqword[_v2],xmm0")
;~     _("")                              ;v3
;~     _("movaps xmm0,xmm1")              ;x1
;~     _("mulps xmm0,xmm5")               ;x1*3
;~     _("mulps xmm0,xmm6")               ;
;~     _("addps xmm0,dqword[_mem2]")
;~     _("mulps xmm0,xmm7")
;~     _("movaps dqword[_v3],xmm0")
;~     _("")                              ;v4
;~     _("movaps xmm0,xmm2")              ;
;~     _("addps xmm0,xmm2")
;~     _("addps xmm0,xmm0")
;~     _("addps xmm0,xmm1")
;~     _("addps xmm0,xmm3")
;~     _("mulps xmm0,xmm7")
;~     _("movaps dqword[_v4],xmm0")
;~     _("movaps xmm1,dqword[_t]")        ;
;~     _("movaps xmm0,xmm4")              ;v1
;~     _("mulps xmm0,xmm1")
;~     _("addps xmm0,dqword[_v2]")
;~     _("mulps xmm0,xmm1")
;~     _("addps xmm0,dqword[_v3]")
;~     _("mulps xmm0,xmm1")
;~     _("addps xmm0,dqword[_v4]")
;~     _("")
;~     _("ret")

;~     _("align 16")
;~     _("_mem1 dd 0.0,0.0,0.0,0.0")
;~     _("_mem2 dd 0.0,0.0,0.0,0.0")
;~     _("_mem3 dd 0.0,0.0,0.0,0.0")

;~     _("_mem5 dd 3.0,3.0,3.0,3.0")
;~     _("_mem6 dd -1.0,-1.0,-1.0,-1.0")

;~     _("")
;~     _("_v1 dd 0.0,0.0,0.0,0.0")
;~     _("_v2 dd 0.0,0.0,0.0,0.0")
;~     _("_v3 dd 0.0,0.0,0.0,0.0")
;~     _("_v4 dd 0.0,0.0,0.0,0.0")
;~     _("_t dd 0.5,0.5,0.5,0.5")

;~ EndFunc                                ;==>_asm


